unit Convert;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls;

type

  { TImageToVP5500 }

  TImageToVP5500 = class(TForm)
    OpenDialog: TOpenDialog;
    ProgressBar: TProgressBar;
    SaveDialog: TSaveDialog;
    S_Button: TButton;
    Oe_Button: TButton;
    Image: TImage;
    procedure Oe_ButtonClick(Sender: TObject);
    procedure S_ButtonClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  ImageToVP5500: TImageToVP5500;

const
  image_Width  = 240;
  image_Height = 220;
  disp_Width   = 176;
  disp_Height  = 220;

implementation

{ TImageToVP5500 }

procedure GetRGB(const Color: TColor; var R, G, B: byte);
begin
  // convert hexa-decimal values to RGB
  R := Color and $FF;
  G := (Color shr 8) and $FF;
  B := (Color shr 16) and $FF;
end;

function GetRGB565(Color: TColor): Word;
var
  r, b, g: byte;
begin
  GetRGB(Color, r, g, b);
  r      := r shr 3;
  g      := g shr 2;
  b      := b shr 3;
  Result := b OR (g shl 5) OR (r shl 11);
end;

procedure TImageToVP5500.S_ButtonClick(Sender: TObject);
var
  OutFile: TFileStream;
  x, y:    integer;
begin
  if SaveDialog.Execute then
  begin
    OutFile := TFileStream.Create(SaveDialog.FileName+'.rgb565', fmCreate);
    try
      for x := 0 to image_Height - 1 do
      begin
        for y := 0 to image_Width - 1 do
        begin
          if y > disp_Width-1 then
            OutFile.WriteWord($FFFF)
          else
            OutFile.WriteWord(GetRGB565(Image.canvas.Pixels[y, x]));
        end;
        ProgressBar.Position := round(x * 100 / (image_Height - 1));
      end;
    finally
      OutFile.Free;
    end;
  end;
end;

procedure TImageToVP5500.Oe_ButtonClick(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    Image.Picture.LoadFromFile(OpenDialog.Filename);
  end;
end;

initialization
  {$I convert.lrs}

end.

